// period of pulse accumulation and serial output, milliseconds
#define MainPeriod 100
long previousMillis = 0; // will store last time of the cycle end
volatile unsigned long duration=0; // accumulates pulse width
volatile unsigned int pulsecount=0;
volatile unsigned long previousMicros=0;
int pin = 3;
int ticker = 0;

void setup()
{
  Serial.begin(9600); 
  attachInterrupt(0, myinthandler, RISING);
  pinMode(pin, OUTPUT);
}

void loop()
{
    while (ticker < 10) {
  long randVal = random(31, 20000);
  Serial.print("\t");
  Serial.print(randVal);
  Serial.print("\t");
  delay(1000);
if (randVal < 3100){
    tone(pin, randVal);
    Serial.println(randVal);
    Serial.println("YES");
    delay(800);    
  }
else{
    Serial.println("\t");
    Serial.println("NO");
    delay(800);
  }
  ticker++;
    }
    ticker = 0;
    //delay(1000);
  unsigned long currentMillis = millis();
  if (currentMillis - previousMillis >= MainPeriod) 
  {
    previousMillis = currentMillis;   
    // need to bufferize to avoid glitches
    unsigned long _duration = duration;
    unsigned long _pulsecount = pulsecount;
    duration = 0; // clear counters
    pulsecount = 0;
    float Freq = 1e6 / float(_duration);
    Freq *= _pulsecount; // calculate F
    Serial.println("\t");
    Serial.println(Freq);
    Serial.println("\t");
    delay(1000);
    if (Freq > 2000)
    {
      Serial.print("\t");
      Serial.print("DONE");
      //Serial.print("\t");
    }
   
  }
}

void myinthandler() // interrupt handler
{
  unsigned long currentMicros = micros();
  duration += currentMicros - previousMicros;
  previousMicros = currentMicros;
  pulsecount++;
}
