/*
  AnalogReadSerial
  Reads an analog input on pin 0, prints the result to the serial monitor.
  Attach the center pin of a potentiometer to pin A0, and the outside pins to +5V and ground.

 This example code is in the public domain.
 */
double pin_led = 2;

// the setup routine runs once when you press reset:
void setup() {
  // initialize serial communication at 9600 bits per second:
 pinMode(2, OUTPUT);
  Serial.begin(9600);
}

// the loop routine runs over and over again forever:
void loop() {
  // read the input on analog pin 0:
  int sensorValue = analogRead(A0);
   Serial.println(sensorValue);
  if (sensorValue > 600)
  {
    // Send command for baud rate 5600
    Serial.flush();
      Serial.begin(57600);
      digitalWrite(2, HIGH);
      delay(400);
     
  }
  else if (sensorValue <= 600)
  {
    Serial.flush();
      Serial.begin(19200);// Send baud rate command for 2400
  }
  else
  {
    
  }
  // print out the value you read:
  Serial.println(sensorValue);
  analogWrite(4 , sensorValue);
  delay(400);        // delay in between reads for stability
}
